
//
// To jest przykładowy kod z podrozdziału 23.4 „Słowniki” książki
// "Programowanie. Teoria i praktyka z wykorzystaniem C++" Bjarne'a Stroustrupa.
//

#include<string>
#include<vector>
#include<map>
#include<fstream>
#include<iostream>

using namespace std;

//------------------------------------------------------------------------------

// Obiekt klasy message to zgodnie z naszą definicją para iteratorów wektora vector<string> (naszego wektora wierszy tekstu):
typedef vector<string>::const_iterator Line_iter;

class Message {  // Message wskazuje pierwszy i ostatni wiersz wiadomości.
    Line_iter first;
    Line_iter last;
public:
    Message(Line_iter p1, Line_iter p2) :first(p1), last(p2) { }
    Line_iter begin() const { return first; }
    Line_iter end() const { return last; }
    // ...
};

//------------------------------------------------------------------------------

typedef vector<Message>::const_iterator Mess_iter;

//------------------------------------------------------------------------------

// Mail_file przechowuje wszystkie wiersze z pliku i wiadomości
struct Mail_file {        // Mail_file przechowuje wszystkie wiersze z pliku
                          // i ułatwia dostęp do wiadomości.
    string name;          // nazwa pliku
    vector<string> lines; // uporządkowane wiersze
    vector<Message> m;    // uporządkowane wiadomości

    Mail_file(const string& n);  // wczytuje plik n do lines

    Mess_iter begin() const { return m.begin(); }
    Mess_iter end() const { return m.end(); }
};

//------------------------------------------------------------------------------

// Znajduje nazwę nadawcy wiadomości.
// Zwraca true, jeśli znajdzie nazwę i
// Wstawia nazwę nadawcy do s, jeśli ją znajdzie
bool find_from_addr(const Message* m, string& s);

//------------------------------------------------------------------------------

// Zwraca temat wiadomości, jeśli jest, lub "" w przeciwnym przypadku
string find_subject(const Message* m);

//------------------------------------------------------------------------------

int main()
{
    Mail_file mfile("my-mail-file.txt");        // Inicjacja mfile zawartością pliku.

    // Najpierw gromadzone są wszystkie wiadomości w kontenerze multimap:

    multimap<string, const Message*> sender;

    for (Mess_iter p = mfile.begin(); p!=mfile.end(); ++p) {
        const Message& m = *p;
        string s;
        if (find_from_addr(&m,s))
            sender.insert(make_pair(s,&m));
    }

    // Iteracja przez kontener multimap
    // i wydobywanie tematów wiadomości od Jana Zebry:
    typedef multimap<string, const Message*>::const_iterator MCI;
    pair<MCI,MCI> pp = sender.equal_range("Jan Zebra");
    for(MCI p = pp.first; p!=pp.second; ++p)
        cout << find_subject(p->second) << '\n';
}

//------------------------------------------------------------------------------
